#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

#define KEYSEM1 1
#define KEYSEM2 2
#define KEYSEM3 3

void sinyal12(void)
{
}

void sem_signal(int semid, int val)
{
  struct sembuf semafor;

  semafor.sem_num=0;
  semafor.sem_op=val;
  semafor.sem_flg=1;
  semop(semid, &semafor,1);
}

void sem_wait(int semid, int val)
{
  struct sembuf semafor;

  semafor.sem_num=0;
  semafor.sem_op=(-1*val);
  semafor.sem_flg=1;
  semop(semid, &semafor,1);
}

int main (void)
{
  int sem1, 
      sem2, 
      sonsem, 
      c[2],
      f,
      i,
      siram;

  signal(12, (sighandler_t) sinyal12);


  for (i=0; i<2; i++)
  {
    f=fork();
    if (f==0)
      break;
    else
      c[i]=f;
  }
  if (f==-1)
  {
    printf("FORK hata....\n");
    exit(1);
  }

  if (f!=0)
  {
    printf("Anne kaynaklari yaratmaya basliyor....\n");
    sem1=semget(KEYSEM1, 1, 0700|IPC_CREAT);
    semctl(sem1, 0, SETVAL,1);

    sem2=semget(KEYSEM2,1,0700|IPC_CREAT);
    semctl(sem2,0,SETVAL,1);

    sonsem=semget(KEYSEM3,1,0700|IPC_CREAT);
    semctl(sonsem,0,SETVAL,0);

    sleep(2);
    printf("Anne cocuklari baslatiyor .......\n");
    for (i=0; i<2; i++)
      kill(c[i],12);

    sem_wait(sonsem,2);

    printf("Anne: Cocuklarin isi bitti, kaynaklar iade ediliyor...\n");
    semctl(sonsem,0,IPC_RMID,0);
    semctl(sem1,0,IPC_RMID,0);
    semctl(sem2,0,IPC_RMID,0);
    exit(0);
  }
  else
  {
    siram=i;
    printf("cocuk %d anneden haber bekliyor ....\n", siram);
    pause();
    sem1=semget(KEYSEM1,1,0);
    sem2=semget(KEYSEM2,1,0);
    sonsem=semget(KEYSEM3,1,0);
    printf("cocuk %d anneden haber aldi, basliyor ....\n", siram);
    if (siram==0)
    {
      printf("cocuk %d: sem1 eksiltiyorum.\n", siram);
      sem_wait(sem1,1);
      sleep(1);
      printf("cocuk %d: sem1 tamam, sem2 eksiltiyorum.\n", siram);
      sem_wait(sem2,1);
      printf("cocuk %d: kritik bolgemdeyim.\n", siram);
      sleep(5);    /* K.B. islemleri */
      sem_signal(sem2,1);
      sem_signal(sem1,1);
      sem_signal(sonsem,1);
    }
    else if (siram==1)
    {
      printf("    cocuk %d: sem2 eksiltiyorum.\n", siram);
      sem_wait(sem2,1);
      sleep(1);
      printf("    cocuk %d: sem2 tamam, sem1 eksiltiyorum.\n", siram);
      sem_wait(sem1,1);
      printf("    cocuk %d: kritik bolgemdeyim.\n", siram);
      sleep(5);    /* K.B. islemleri */
      sem_signal(sem1,1);
      sem_signal(sem2,1);
      sem_signal(sonsem,1);
    }
  }
  return 0;
}
